<?php

/**
*  Класс для работы с алгоритмом сжатия LZMA
* 
* Зависит от Temp, FileBuffer и lzma.exe
* 
*/
class Lzma {

    private static $_error;
 /*
    public static function decompress( $string, $size = false ){  
        
        $uncompressedFile = Temp::getFileName();  
        $compressedFile = $uncompressedFile . ".lzma";  
        
        if( !$size ) {
            
            $string = substr( $string, 0, 5 ) . pack( 'Q', 0xFFFFFFFFFFFFFFFF ) . substr( $string, 5 );
            
        }

        if( @file_put_contents( $compressedFile, $string ) === false ){

            return self::_error( "Не удалось записать временный файл" );

        };

        $exe = __DIR__ . "\\bin\\lzma.exe";
        $cmd = "\"{$exe}\" d \"$compressedFile\" \"$uncompressedFile\"";

        if( system( $cmd, $code ) === false ){

            return self::_error( "Не удалось запустить декомпрессор" );    

        };
        
        unlink( $compressedFile );

        if( $code ){

            return self::_error( "Ошибка декомпрессии" );

        }

        $string = @file_get_contents( $uncompressedFile );
        unlink( $uncompressedFile );

        if( $string === false ) {

            return self::_error( "Не удалось прочитать временный файл" );

        }

        return $string;

    }
 */   
    public static function decode( $data ){  
        
        $uncompressedFile = Temp::getFileName();  
        $compressedFile = $uncompressedFile . ".lzma";  

        if( @file_put_contents( $compressedFile, $data ) === false ){

            return self::_error( "Не удалось записать временный файл" );

        };

        $exe = __DIR__ . "\\bin\\lzma.exe";
        $cmd = "\"{$exe}\" d \"$compressedFile\" \"$uncompressedFile\"";

        if( exec( $cmd, $output, $code ) === false ){

        	unlink( $compressedFile );
            return self::_error( "Не удалось запустить декомпрессор" );    

        };
        
        unlink( $compressedFile );

        if( $code ){

            return self::_error( "Ошибка декомпрессии" );

        }

        $string = @file_get_contents( $uncompressedFile );
        unlink( $uncompressedFile );

        if( $string === false ) {

            return self::_error( "Не удалось прочитать временный файл" );

        }

        return $string;

    }

    private static function _error( $error ){

        self::$_error = $error;

        return false;

    }

    public static function getLastError(){

        return self::$_error;

    }
}

?>