<?php

class Zstd {

	protected $error;

	public static function decode( $data ){  

		$uncompressedFile = Temp::getFileName();     
		$compressedFile = $uncompressedFile . ".zst";     
		
		if( false === file_put_contents( $compressedFile, $data ) ){
			
			return false;
			
		};
   
   		$exe = __DIR__ . '\bin\zstd.exe';
        $cmd = "\"{$exe}\" -df \"{$compressedFile}\" -o \"{$uncompressedFile}\"";  		
	 	exec( $cmd, $output, $error );
	 	
	 	unlink( $compressedFile ); 
	 	
	 	if( $error !== 0 ){
			
			return false;
			
	 	}
	 	
	 	$unpacked = file_get_contents( $uncompressedFile );
	 	
	 	unlink( $uncompressedFile );

		return $unpacked;

	}


}

?>
