<?php

class BaseClass {

	protected $error = "OK";

	public function getError(){

		return $this->error;

	}

	protected function _error( $msg = "Неизвестная ошибка" ){

		$this->error = $msg;
		
		return false;

	}
	
	protected function _fatal( $msg = "" ){

		$stack = debug_backtrace( 2 );   
		//	print_r( $stack );        		
		
		echo "<pre>Неустранимая ошибка в методе {$stack[1]['class']}{$stack[1]['type']}{$stack[1]['function']}()<br>";     
		echo "Строка {$stack[0]['line']} файл '{$stack[0]['file']}'<br>";
		echo "{$msg}<br>";

		die();

	}   

}

class BaseStaticClass {

	protected static $error = "OK";

	public static function getError(){

		return self::$error;

	}

	protected static function _error( $msg = "Unknown error" ){

		self::$error = $msg;	
			
		return false;

	}
	
	protected static function _fatal(){

		$stack = debug_backtrace( 2 );   
		
		echo "<pre>Неустранимая ошибка в методе {$stack[1]['class']}{$stack[1]['type']}{$stack[1]['function']}()<br>";     
		echo "Строка {$stack[0]['line']} файл '{$stack[0]['file']}'<br>";

		die();

	}

}

?>
